blob: e7b7eee31538e69963874ae3e326a254dac54622 [file] [log] [blame]
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02001#!/bin/sh
2#
3# link vmlinux
4#
5# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and
Nicholas Piggin3a166fc2017-06-20 01:52:05 +10006# $(KBUILD_VMLINUX_MAIN) and $(KBUILD_VMLINUX_LIBS). Most are built-in.o files
7# from top-level directories in the kernel tree, others are specified in
8# arch/$(ARCH)/Makefile. Ordering when linking is important, and
9# $(KBUILD_VMLINUX_INIT) must be first. $(KBUILD_VMLINUX_LIBS) are archives
10# which are linked conditionally (not within --whole-archive), and do not
11# require symbol indexes added.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020012#
13# vmlinux
14# ^
15# |
16# +-< $(KBUILD_VMLINUX_INIT)
17# | +--< init/version.o + more
18# |
19# +--< $(KBUILD_VMLINUX_MAIN)
20# | +--< drivers/built-in.o mm/built-in.o + more
21# |
Nicholas Piggin3a166fc2017-06-20 01:52:05 +100022# +--< $(KBUILD_VMLINUX_LIBS)
23# | +--< lib/lib.a + more
24# |
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020025# +-< ${kallsymso} (see description in KALLSYMS section)
26#
27# vmlinux version (uname -v) cannot be updated during normal
28# descending-into-subdirs phase since we do not yet know if we need to
29# update vmlinux.
30# Therefore this step is delayed until just before final link of vmlinux.
31#
32# System.map is generated to document addresses of all kernel symbols
33
34# Error out on error
35set -e
36
37# Nice output in kbuild format
38# Will be supressed by "make -s"
39info()
40{
41 if [ "${quiet}" != "silent_" ]; then
42 printf " %-7s %s\n" ${1} ${2}
43 fi
44}
45
Nicholas Piggin3a166fc2017-06-20 01:52:05 +100046# Thin archive build here makes a final archive with symbol table and indexes
47# from vmlinux objects INIT and MAIN, which can be used as input to linker.
48# KBUILD_VMLINUX_LIBS archives should already have symbol table and indexes
49# added.
Stephen Rothwella5967db2016-08-24 22:29:19 +100050#
51# Traditional incremental style of link does not require this step
52#
53# built-in.o output file
54#
55archive_builtin()
56{
57 if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
58 info AR built-in.o
59 rm -f built-in.o;
Nicholas Piggin9a6cfca2017-06-09 15:24:14 +100060 ${AR} rcsTP${KBUILD_ARFLAGS} built-in.o \
Stephen Rothwella5967db2016-08-24 22:29:19 +100061 ${KBUILD_VMLINUX_INIT} \
62 ${KBUILD_VMLINUX_MAIN}
63 fi
64}
65
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020066# Link of vmlinux.o used for section mismatch analysis
67# ${1} output file
68modpost_link()
69{
Stephen Rothwella5967db2016-08-24 22:29:19 +100070 local objects
71
72 if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
Nicholas Piggin3a166fc2017-06-20 01:52:05 +100073 objects="--whole-archive \
74 built-in.o \
75 --no-whole-archive \
76 --start-group \
77 ${KBUILD_VMLINUX_LIBS} \
78 --end-group"
Stephen Rothwella5967db2016-08-24 22:29:19 +100079 else
80 objects="${KBUILD_VMLINUX_INIT} \
81 --start-group \
82 ${KBUILD_VMLINUX_MAIN} \
Nicholas Piggin3a166fc2017-06-20 01:52:05 +100083 ${KBUILD_VMLINUX_LIBS} \
Stephen Rothwella5967db2016-08-24 22:29:19 +100084 --end-group"
85 fi
86 ${LD} ${LDFLAGS} -r -o ${1} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020087}
88
89# Link of vmlinux
90# ${1} - optional extra .o files
91# ${2} - output file
92vmlinux_link()
93{
94 local lds="${objtree}/${KBUILD_LDS}"
Stephen Rothwella5967db2016-08-24 22:29:19 +100095 local objects
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020096
97 if [ "${SRCARCH}" != "um" ]; then
Stephen Rothwella5967db2016-08-24 22:29:19 +100098 if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
Nicholas Piggin3a166fc2017-06-20 01:52:05 +100099 objects="--whole-archive \
100 built-in.o \
101 --no-whole-archive \
102 --start-group \
103 ${KBUILD_VMLINUX_LIBS} \
104 --end-group \
105 ${1}"
Stephen Rothwella5967db2016-08-24 22:29:19 +1000106 else
107 objects="${KBUILD_VMLINUX_INIT} \
108 --start-group \
109 ${KBUILD_VMLINUX_MAIN} \
Nicholas Piggin3a166fc2017-06-20 01:52:05 +1000110 ${KBUILD_VMLINUX_LIBS} \
Stephen Rothwella5967db2016-08-24 22:29:19 +1000111 --end-group \
112 ${1}"
113 fi
114
115 ${LD} ${LDFLAGS} ${LDFLAGS_vmlinux} -o ${2} \
116 -T ${lds} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200117 else
Stephen Rothwella5967db2016-08-24 22:29:19 +1000118 if [ -n "${CONFIG_THIN_ARCHIVES}" ]; then
Nicholas Piggin3a166fc2017-06-20 01:52:05 +1000119 objects="-Wl,--whole-archive \
120 built-in.o \
121 -Wl,--no-whole-archive \
122 -Wl,--start-group \
123 ${KBUILD_VMLINUX_LIBS} \
124 -Wl,--end-group \
125 ${1}"
Stephen Rothwella5967db2016-08-24 22:29:19 +1000126 else
127 objects="${KBUILD_VMLINUX_INIT} \
128 -Wl,--start-group \
129 ${KBUILD_VMLINUX_MAIN} \
Nicholas Piggin3a166fc2017-06-20 01:52:05 +1000130 ${KBUILD_VMLINUX_LIBS} \
Stephen Rothwella5967db2016-08-24 22:29:19 +1000131 -Wl,--end-group \
132 ${1}"
133 fi
134
135 ${CC} ${CFLAGS_vmlinux} -o ${2} \
136 -Wl,-T,${lds} \
137 ${objects} \
138 -lutil -lrt -lpthread
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200139 rm -f linux
140 fi
141}
142
143
144# Create ${2} .o file with all symbols from the ${1} object file
145kallsyms()
146{
147 info KSYM ${2}
148 local kallsymopt;
149
Rusty Russellb92021b2013-03-15 15:04:17 +1030150 if [ -n "${CONFIG_HAVE_UNDERSCORE_SYMBOL_PREFIX}" ]; then
151 kallsymopt="${kallsymopt} --symbol-prefix=_"
James Hogan6895f972012-09-06 22:11:25 +0100152 fi
153
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200154 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
James Hogan6895f972012-09-06 22:11:25 +0100155 kallsymopt="${kallsymopt} --all-symbols"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200156 fi
157
Ard Biesheuvel4d5d5662016-03-15 14:58:12 -0700158 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
Rusty Russellc6bda7c2014-03-17 14:05:46 +1030159 kallsymopt="${kallsymopt} --absolute-percpu"
160 fi
161
Ard Biesheuvel2213e9a2016-03-15 14:58:19 -0700162 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
163 kallsymopt="${kallsymopt} --base-relative"
164 fi
165
Sam Ravnborg00e6c28c2012-05-08 19:53:46 +0200166 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
167 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200168
Ard Biesheuvela0439342016-02-05 11:25:05 +0100169 local afile="`basename ${2} .o`.S"
170
171 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
172 ${CC} ${aflags} -c -o ${2} ${afile}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200173}
174
175# Create map file with all symbols from ${1}
176# See mksymap for additional details
177mksysmap()
178{
179 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
180}
181
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700182sortextable()
183{
184 ${objtree}/scripts/sortextable ${1}
185}
186
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200187# Delete output files in case of error
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200188cleanup()
189{
190 rm -f .old_version
191 rm -f .tmp_System.map
192 rm -f .tmp_kallsyms*
193 rm -f .tmp_version
194 rm -f .tmp_vmlinux*
Stephen Rothwella5967db2016-08-24 22:29:19 +1000195 rm -f built-in.o
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200196 rm -f System.map
197 rm -f vmlinux
198 rm -f vmlinux.o
199}
200
Sylvain BERTRANDab160db2015-05-07 00:36:04 +0000201on_exit()
202{
203 if [ $? -ne 0 ]; then
204 cleanup
205 fi
206}
207trap on_exit EXIT
208
209on_signals()
210{
211 exit 1
212}
213trap on_signals HUP INT QUIT TERM
214
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200215#
216#
217# Use "make V=1" to debug this script
218case "${KBUILD_VERBOSE}" in
219*1*)
220 set -x
221 ;;
222esac
223
224if [ "$1" = "clean" ]; then
225 cleanup
226 exit 0
227fi
228
229# We need access to CONFIG_ symbols
Michal Marek423a8152013-02-25 13:47:53 +0100230case "${KCONFIG_CONFIG}" in
231*/*)
232 . "${KCONFIG_CONFIG}"
233 ;;
234*)
235 # Force using a file from the current directory
236 . "./${KCONFIG_CONFIG}"
237esac
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200238
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200239# Update version
240info GEN .version
241if [ ! -r .version ]; then
242 rm -f .version;
243 echo 1 >.version;
244else
245 mv .version .old_version;
246 expr 0$(cat .old_version) + 1 >.version;
247fi;
248
249# final build of init/
Emese Revfy6b90bd42016-05-24 00:09:38 +0200250${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init GCC_PLUGINS_CFLAGS="${GCC_PLUGINS_CFLAGS}"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200251
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100252archive_builtin
253
254#link vmlinux.o
255info LD vmlinux.o
256modpost_link vmlinux.o
257
258# modpost vmlinux.o to check for section mismatches
259${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
260
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200261kallsymso=""
262kallsyms_vmlinux=""
263if [ -n "${CONFIG_KALLSYMS}" ]; then
264
265 # kallsyms support
266 # Generate section listing all symbols and add it into vmlinux
267 # It's a three step process:
268 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
269 # but __kallsyms is empty.
270 # Running kallsyms on that gives us .tmp_kallsyms1.o with
271 # the right size
272 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
273 # the right size, but due to the added section, some
274 # addresses have shifted.
275 # From here, we generate a correct .tmp_kallsyms2.o
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100276 # 3) That link may have expanded the kernel image enough that
277 # more linker branch stubs / trampolines had to be added, which
278 # introduces new names, which further expands kallsyms. Do another
279 # pass if that is the case. In theory it's possible this results
280 # in even more stubs, but unlikely.
281 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
282 # other bugs.
283 # 4) The correct ${kallsymso} is linked into the final vmlinux.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200284 #
285 # a) Verify that the System.map from vmlinux matches the map from
286 # ${kallsymso}.
287
288 kallsymso=.tmp_kallsyms2.o
289 kallsyms_vmlinux=.tmp_vmlinux2
290
291 # step 1
292 vmlinux_link "" .tmp_vmlinux1
293 kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
294
295 # step 2
296 vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
297 kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
298
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100299 # step 3
300 size1=$(stat -c "%s" .tmp_kallsyms1.o)
301 size2=$(stat -c "%s" .tmp_kallsyms2.o)
302
303 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200304 kallsymso=.tmp_kallsyms3.o
305 kallsyms_vmlinux=.tmp_vmlinux3
306
307 vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
308
309 kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
310 fi
311fi
312
313info LD vmlinux
314vmlinux_link "${kallsymso}" vmlinux
315
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700316if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
317 info SORTEX vmlinux
318 sortextable vmlinux
319fi
320
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200321info SYSMAP System.map
322mksysmap vmlinux System.map
323
324# step a (see comment above)
325if [ -n "${CONFIG_KALLSYMS}" ]; then
326 mksysmap ${kallsyms_vmlinux} .tmp_System.map
327
328 if ! cmp -s System.map .tmp_System.map; then
Michal Marek5369f552012-07-07 23:04:40 +0200329 echo >&2 Inconsistent kallsyms data
Michal Marek367e43c2012-08-10 11:55:11 +0200330 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200331 exit 1
332 fi
333fi
334
335# We made a new kernel - delete old version file
336rm -f .old_version